/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gwf_lib.h>
#include <gmodule.h>
#include <gtk/gtk.h>

#include "gwf_projtree_elem.h"
#include "gwf_source_elem.h"
#include "gwf_widprop_elem.h"
#include "gwf_xmlio_elem.h"
#include "gwf_projdata_elem.h"

#define N_ERR		2

static GwfErrData		errmsg[N_ERR] =    {
							{"XmlIO : Element no name",GWF_ERROR,"Element encountered without a name"},
							{"Source : Elem : Invalid elem",GWF_ERROR,"One or more of the element definitions are invalid"}
 						   };
 						
G_MODULE_EXPORT GwfPlugin*
gwf_new_elem_plugin (void)
{
  GwfPlugin	*tmp;
  gint		i;

  tmp = gwf_plugin_new("Elements");
  tmp->version = g_strdup("0.1.0");
  tmp->href = g_strdup("http://gwf.sourceforge.net/Elements");

  tmp->load_plugin = gwf_xmlio_load_element;
  tmp->save_plugin = gwf_xmlio_save_element;

  tmp->new_data = gwf_project_element_new;

  tmp->setting_create = gwf_widpropelem_new;

  tmp->source_check = gwf_source_elem_check;
  gwf_plugin_add_srcwrt(tmp,TYPE,gwf_source_elem_write_elem_types,HFILE);
  gwf_plugin_add_srcwrt(tmp,FUNC_DECL,gwf_source_elem_write_func_decl,HFILE);
  gwf_plugin_add_srcwrt(tmp,FUNCTION,gwf_source_elem_write_init_func,CFILE);
  gwf_plugin_add_srcwrt(tmp,FUNCTION,gwf_source_elem_write_funcs,CFILE);

  tmp->tree_attach = gwf_projtree_elem_attach;
  tmp->tree_free = NULL;

  for (i = 0 ; i < N_ERR; i++)
  {
    g_ptr_array_add(tmp->errmsg,&errmsg[i]);
  }

  return tmp;
}
